import React from 'react'
import PropTypes from 'prop-types'
import clsx from 'clsx'

import classes from './spinner.module.less'

/**
 * amiv Spinner / loading animation
 *
 * @component
 */
const Spinner = ({ size, centered, show, className }) => {
  let sizeNum
  if (size === 'small') {
    sizeNum = 32
  } else if (size === 'large') {
    sizeNum = 64
  } else {
    sizeNum = 48
  }

  return (
    <div
      className={clsx(
        classes.root,
        classes[size],
        centered && classes.rootCentered,
        show && classes.rootVisible,
        className
      )}
    >
      <div className={classes.container}>
        {/* amiv Diode */}
        <svg width={sizeNum} height={sizeNum} viewBox="0 0 48 48">
          <style type="text/css">.st0{'{fill:#E8462B;}'}</style>
          <path
            className="st0"
            d="M24.6,20.2l-12.8,1.3l3.8,5.3l-6,4.4c0,0.9,1.9,3.7,3.2,4.5l6.1-4.4l4.1,5.6l5.1-11.8l3.8,5.2l4.5-3.2l-4-5.6l5.2-3.8c-0.8-1.7-1.9-3.2-3.2-4.5L29.2,17l-4-5.6l-4.5,3.2l4.1,5.6l0,0"
          />
        </svg>
        {/* amiv gear */}
        <svg
          width={sizeNum}
          height={sizeNum}
          viewBox="0 0 48 48"
          className={clsx(classes.icons, classes.gear)}
        >
          <style type="text/css">.st0{'{fill:#E8462B;}'}</style>
          <path
            className="st0"
            d="M48.6,27.3c0.3-2.2,0.3-4.3,0-6.5l-5.7-0.9c-0.3-1.2-0.6-2.3-1.1-3.4l4.1-4.1c-0.5-1-1.1-1.9-1.7-2.8c-0.6-0.9-1.3-1.7-2.1-2.5l-5.2,2.7c-0.4-0.4-0.9-0.8-1.4-1.1c-0.5-0.4-1-0.7-1.5-1L35,2c-1-0.5-2-0.9-3-1.2c-1-0.3-2.1-0.6-3.2-0.8l-2.6,5.2c-1.2-0.1-2.3-0.1-3.5,0L20.1,0c-1.1,0.2-2.1,0.5-3.2,0.8c-1,0.3-2,0.8-3,1.2l0.9,5.7c-1,0.6-2,1.3-2.9,2.1L6.7,7.2C6,8,5.3,8.8,4.7,9.7c-0.6,0.9-1.2,1.8-1.7,2.8l4.1,4.1c-0.5,1.1-0.8,2.2-1.1,3.3l-5.8,0.9c-0.3,2.2-0.3,4.3,0,6.5L6,28.2c0.3,1.1,0.6,2.3,1.1,3.3l-4.1,4.1c0.5,1,1.1,1.9,1.7,2.8C5.3,39.3,6,40.2,6.8,41l5.2-2.7c0.4,0.4,0.9,0.8,1.4,1.1c0.5,0.4,1,0.7,1.5,1l-0.9,5.7c1,0.5,2,0.9,3,1.2c1,0.3,2.1,0.6,3.2,0.8l2.6-5.2c1.2,0.1,2.3,0.1,3.5,0l2.6,5.2c1.1-0.2,2.1-0.5,3.2-0.8c1-0.3,2-0.7,3-1.2L34,40.4c1-0.6,2-1.3,2.9-2.1l5.2,2.7c0.8-0.8,1.5-1.6,2.1-2.5c0.6-0.9,1.2-1.8,1.7-2.8l-4.1-4.1c0.5-1.1,0.8-2.2,1.1-3.4L48.6,27.3z M35.5,32.1c-0.1,0.2-0.3,0.4-0.4,0.5s-0.1,0.1-0.1,0.2c-0.2,0.3-0.5,0.6-0.8,0.8l-0.1,0.1c-0.3,0.3-0.5,0.5-0.8,0.8l-0.2,0.1c-0.3,0.2-0.6,0.4-0.9,0.6L32,35.5L31.1,36l-0.4,0.2c-0.2,0.1-0.5,0.2-0.8,0.3l-0.5,0.2L28.8,37l-0.7,0.2l-0.6,0.2c-0.2,0.1-0.5,0.1-0.7,0.2l-0.6,0.1l-0.7,0.1h-0.7h-0.4h-0.2h-0.8l-0.6,0l-0.7-0.1c-0.2,0-0.4-0.1-0.6-0.1s-0.4-0.1-0.6-0.2l-0.7-0.2c-0.2-0.1-0.4-0.1-0.6-0.2s-0.5-0.2-0.7-0.3l-0.5-0.2L17.7,36c-0.2-0.1-0.3-0.2-0.5-0.3s-0.5-0.3-0.7-0.5l-0.2-0.1c-0.1-0.1-0.2-0.1-0.2-0.2c-0.2-0.2-0.5-0.4-0.7-0.6l-0.2-0.1l0,0c-2.7-2.5-4.4-5.9-4.5-9.6v-0.1c0-0.2,0-0.3,0-0.5c0-0.6,0.1-1.3,0.1-1.9l0.1-0.4c0-0.2,0.1-0.5,0.1-0.7s0.1-0.4,0.1-0.6s0.2-0.6,0.3-0.9s0.1-0.3,0.2-0.5s0.1-0.4,0.2-0.5s0.2-0.5,0.4-0.8s0.2-0.4,0.3-0.6s0.2-0.4,0.3-0.6l0.3-0.4l0.1-0.2l0.2-0.2c0.2-0.2,0.3-0.5,0.5-0.7l0.4-0.4c0.2-0.2,0.3-0.4,0.5-0.5s0.3-0.3,0.5-0.4s0.4-0.3,0.6-0.5l0.5-0.4l0.6-0.4l0.5-0.3l0.7-0.4l0.4-0.2l0.8-0.3l0.4-0.1c0.3-0.1,0.6-0.2,0.9-0.3l0.4-0.1c0.3-0.1,0.6-0.1,0.8-0.2c0.2,0,0.3-0.1,0.5-0.1l0.8-0.1H24h0.4h0.2c0.3,0,0.5,0,0.8,0H26l0.9,0.1l0.5,0.1c0.3,0.1,0.6,0.1,0.9,0.2l0.4,0.1c0.3,0.1,0.6,0.2,0.9,0.3l0.3,0.1c0.3,0.1,0.6,0.3,0.9,0.4l0.3,0.1c0.3,0.2,0.6,0.3,0.8,0.5c0.1,0.1,0.2,0.1,0.3,0.2l0.3,0.2l0.4,0.3c0.2,0.1,0.3,0.3,0.5,0.4c0.1,0.1,0.2,0.2,0.3,0.3l0,0c1.4,1.3,2.4,2.8,3.2,4.5l0,0c0,0,0,0.1,0,0.1c0.1,0.2,0.1,0.3,0.2,0.5s0.2,0.4,0.2,0.6s0.1,0.3,0.2,0.5s0.2,0.6,0.2,0.9s0.1,0.3,0.1,0.5s0.1,0.6,0.1,0.8c0,0.1,0,0.2,0,0.3c0,0.4,0.1,0.8,0.1,1.2c0,0,0,0.1,0,0.1s0,0.1,0,0.1C38.1,27,37.2,29.8,35.5,32.1z"
          />
        </svg>
      </div>
    </div>
  )
}

Spinner.defaultProps = {
  centered: false,
  size: 'medium',
  show: true,
}

Spinner.propTypes = {
  /** Size of the spinner element */
  size: PropTypes.oneOf(['small', 'medium', 'large']),
  /** Use absolute positioning to center component within parent container. */
  centered: PropTypes.bool,
  /** Specifies whether to show the component. */
  show: PropTypes.bool,
  /** @ignore */
  className: PropTypes.string,
}

export default Spinner
